﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;

namespace FriDecomposeTest
{
    class DataStruct
    {
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct CardInfoStruct
        {
            [MarshalAs(UnmanagedType.I4, SizeConst = 1)]
            public int cardType;//证件类型：1=居民身份证、2=港澳台居民居住证、3=2017版永居证、4=新版永居证

            //***居民身份证数据结构***
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 30)]
            public byte[] sfz_name;//姓名
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public byte[] sfz_gender;//性别
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] sfz_nation;//民族
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] sfz_birthday;//出生日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 70)]
            public byte[] sfz_address;//地址
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 36)]
            public byte[] sfz_idNumber;//公民身份号码
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 30)]
            public byte[] sfz_issueOrganization;//签发机关
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] sfz_validDateStart;//有效期起始日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] sfz_validDateEnd;//有效期截止日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 36)]
            public byte[] sfz_reserved;//预留
            //***居民身份证数据结构***

            //***港澳台居民居住证数据结构***
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 30)]
            public byte[] gat_name;//姓名
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public byte[] gat_gender;//性别
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
            public byte[] gat_reserved1;//预留
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] gat_birthday;//出生日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 70)]
            public byte[] gat_address;//地址
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 36)]
            public byte[] gat_idNumber;//公民身份号码
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 30)]
            public byte[] gat_issueOrganization;//签发机关
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] gat_validDateStart;//有效期起始日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] gat_validDateEnd;//有效期截止日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 18)]
            public byte[] gat_passCheckId;//通行证号码
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
            public byte[] gat_issuesNumber;//签发次数
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public byte[] gat_reserved2;//预留
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
            public byte[] gat_cardType;//证件类型标识
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public byte[] gat_reserved3;//预留
            //***港澳台居民居住证数据结构***

            //***2017版永居证数据结构***
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 120)]
            public byte[] yjzOld_nameEnglish;//英文姓名
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public byte[] yjzOld_gender;//性别
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 30)]
            public byte[] yjzOld_idNumber;//公民身份号码
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public byte[] yjzOld_nationality;//国籍
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 30)]
            public byte[] yjzOld_nameChinese;//中文姓名
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] yjzOld_validDateStart;//有效期起始日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] yjzOld_validDateEnd;//有效期截止日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] yjzOld_birthday;//出生日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
            public byte[] yjzOld_cardVersion;//证件版本号
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] yjzOld_issueOrganization;//签发机关
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
            public byte[] yjzOld_cardType;//证件类型标识
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public byte[] yjzOld_reserved;//预留
            //***2017版永居证数据结构***

            //***新版永居证数据结构***
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 30)]
            public byte[] yjz_nameChinese;//中文姓名
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public byte[] yjz_gender;//性别
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
            public byte[] yjz_renewalNumber;//换证次数
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] yjz_birthday;//出生日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 70)]
            public byte[] yjz_nameEnglish;//英文姓名
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 36)]
            public byte[] yjz_idNumber;//公民身份号码
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 30)]
            public byte[] yjz_reserved;//预留
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] yjz_validDateStart;//有效期起始日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] yjz_validDateEnd;//有效期截止日期
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 22)]
            public byte[] yjz_nameEnglishAdd;//英文姓名备用
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public byte[] yjz_nationality;//国籍
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
            public byte[] yjz_cardType;//证件类型标识
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 30)]
            public byte[] yjz_historicalNumber;//历史号码
            //***新版永居证数据结构***

            public CardInfoStruct(int i)
            {
                cardType = 0;

                //***居民身份证数据结构***
                sfz_name = new byte[30];//姓名
                sfz_gender = new byte[6];//性别
                sfz_nation = new byte[8];//民族
                sfz_birthday = new byte[16];//出生日期
                sfz_address = new byte[70];//地址
                sfz_idNumber = new byte[36];//公民身份号码
                sfz_issueOrganization = new byte[30];//签发机关
                sfz_validDateStart = new byte[16];//有效期起始日期
                sfz_validDateEnd = new byte[16];//有效期截止日期
                sfz_reserved = new byte[36];//预留
                //***居民身份证数据结构***

                //***港澳台居民居住证数据结构***
                gat_name = new byte[30];//姓名
                gat_gender = new byte[6];//性别
                gat_reserved1 = new byte[4];//预留
                gat_birthday = new byte[16];//出生日期
                gat_address = new byte[70];//地址
                gat_idNumber = new byte[36];//公民身份号码
                gat_issueOrganization = new byte[30];//签发机关
                gat_validDateStart = new byte[16];//有效期起始日期
                gat_validDateEnd = new byte[16];//有效期截止日期
                gat_passCheckId = new byte[18];//通行证号码
                gat_issuesNumber = new byte[4];//签发次数
                gat_reserved2 = new byte[6];//预留
                gat_cardType = new byte[2];//证件类型标识
                gat_reserved3 = new byte[6];//预留
                //***港澳台居民居住证数据结构***

                //***2017版永居证数据结构***
                yjzOld_nameEnglish = new byte[120];//英文姓名
                yjzOld_gender = new byte[6];//性别
                yjzOld_idNumber = new byte[30];//公民身份号码
                yjzOld_nationality = new byte[6];//国籍
                yjzOld_nameChinese = new byte[30];//中文姓名
                yjzOld_validDateStart = new byte[16];//有效期起始日期
                yjzOld_validDateEnd = new byte[16];//有效期截止日期
                yjzOld_birthday = new byte[16];//出生日期
                yjzOld_cardVersion = new byte[4];//证件版本号
                yjzOld_issueOrganization = new byte[8];//签发机关
                yjzOld_cardType = new byte[2];//证件类型标识
                yjzOld_reserved = new byte[6];//预留
                //***2017版永居证数据结构***

                //***新版永居证数据结构***
                yjz_nameChinese = new byte[30];//中文姓名
                yjz_gender = new byte[6];//性别
                yjz_renewalNumber = new byte[4];//换证次数
                yjz_birthday = new byte[16];//出生日期
                yjz_nameEnglish = new byte[70];//英文姓名
                yjz_idNumber = new byte[36];//公民身份号码
                yjz_reserved = new byte[30];//预留
                yjz_validDateStart = new byte[16];//有效期起始日期
                yjz_validDateEnd = new byte[16];//有效期截止日期
                yjz_nameEnglishAdd = new byte[22];//英文姓名备用
                yjz_nationality = new byte[6];//国籍
                yjz_cardType = new byte[2];//证件类型标识
                yjz_historicalNumber = new byte[30];//历史号码
                //***新版永居证数据结构***
            }
        }
    }
}
