﻿using System;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;
using static FriDecomposeTest.DataStruct;

namespace FriDecomposeTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private void AddListBoxItem(string str, Color cl)
        {
            richTextBox_info.SelectionColor = cl;
            richTextBox_info.AppendText(str + "\n\n");
            richTextBox_info.ScrollToCaret();
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            textBox_iPort.Text = 1001.ToString();
            checkBox_ifFinger.Checked = true;
        }

        private void showData(CardInfoStruct pCardInfoStruct)
        {
            //清空数据
            foreach (TabPage tabPage in tabControl_info.TabPages)
            {
                foreach (Control c in tabPage.Controls)
                {
                    if (c is TextBox)
                    {
                        ((TextBox)(c)).Text = "";
                    }
                }
            }
            Bitmap bitmap = null;
            pictureBox_faceData.Image = bitmap;
            richTextBox_fingerData.Text = "";

            if (pCardInfoStruct.cardType == 1)//居民身份证
            {
                tabControl_info.SelectedIndex = 0;
                textBox_sfzName.Text = Encoding.Unicode.GetString(pCardInfoStruct.sfz_name);
                textBox_sfzGender.Text = Encoding.Unicode.GetString(pCardInfoStruct.sfz_gender);
                textBox_sfzNation.Text = Encoding.Unicode.GetString(pCardInfoStruct.sfz_nation);
                textBox_sfzBirthday.Text = Encoding.Unicode.GetString(pCardInfoStruct.sfz_birthday);
                textBox_sfzAddress.Text = Encoding.Unicode.GetString(pCardInfoStruct.sfz_address);
                textBox_sfzIdNumber.Text = Encoding.Unicode.GetString(pCardInfoStruct.sfz_idNumber);
                textBox_sfzIssueOrganization.Text = Encoding.Unicode.GetString(pCardInfoStruct.sfz_issueOrganization);
                textBox_sfzValidDateStart.Text = Encoding.Unicode.GetString(pCardInfoStruct.sfz_validDateStart);
                textBox_sfzValidDateEnd.Text = Encoding.Unicode.GetString(pCardInfoStruct.sfz_validDateEnd);
                textBox_sfzReserved.Text = Encoding.Unicode.GetString(pCardInfoStruct.sfz_reserved);
            }
            if (pCardInfoStruct.cardType == 2)//港澳台居民居住证
            {
                tabControl_info.SelectedIndex = 1;
                textBox_gatName.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_name);
                textBox_gatGender.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_gender);
                textBox_gatBirthday.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_birthday);
                textBox_gatAddress.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_address);
                textBox_gatIdNumber.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_idNumber);
                textBox_gatIssueOrganization.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_issueOrganization);
                textBox_gatValidDateStart.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_validDateStart);
                textBox_gatValidDateEnd.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_validDateEnd);
                textBox_gatPassCheckId.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_passCheckId);
                textBox_gatIssuesNumber.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_issuesNumber);
                textBox_gatReserved1.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_reserved1);
                textBox_gatReserved2.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_reserved2);
                textBox_gatReserved3.Text = Encoding.Unicode.GetString(pCardInfoStruct.gat_reserved3);
            }
            if (pCardInfoStruct.cardType == 3)//2017版永居证
            {
                tabControl_info.SelectedIndex = 2;
                textBox_yjzOldNameEnglish.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjzOld_nameEnglish);
                textBox_yjzOldGender.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjzOld_gender);
                textBox_yjzOldIdNumber.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjzOld_idNumber);
                textBox_yjzOldNationality.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjzOld_nationality);
                textBox_yjzOldNameChinese.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjzOld_nameChinese);
                textBox_yjzOldValidDateStart.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjzOld_validDateStart);
                textBox_yjzOldValidDateEnd.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjzOld_validDateEnd);
                textBox_yjzOldBirthday.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjzOld_birthday);
                textBox_yjzOldCardVersion.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjzOld_cardVersion);
                textBox_yjzOldIssueOrganization.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjzOld_issueOrganization);
                textBox_yjzOldReserved.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjzOld_reserved);
            }
            if (pCardInfoStruct.cardType == 4)//新版永居证
            {
                tabControl_info.SelectedIndex = 3;
                textBox_yjzNameChinese.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_nameChinese);
                textBox_yjzGender.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_gender);
                textBox_yjzRenewalNumber.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_renewalNumber);
                textBox_yjzBirthday.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_birthday);
                textBox_yjzNameEnglish.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_nameEnglish);
                textBox_yjzIdNumber.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_idNumber);
                textBox_yjzReserved.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_reserved);
                textBox_yjzValidDateStart.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_validDateStart);
                textBox_yjzValidDateEnd.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_validDateEnd);
                textBox_yjzNameEnglishAdd.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_nameEnglishAdd);
                textBox_yjzNationality.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_nationality);
                textBox_yjzHistoricalNumber.Text = Encoding.Unicode.GetString(pCardInfoStruct.yjz_historicalNumber);
            }
        }

        private void button_clean_Click(object sender, EventArgs e)
        {
            foreach (TabPage tabPage in tabControl_info.TabPages)
            {
                foreach (Control c in tabPage.Controls)
                {
                    if (c is TextBox)
                    {
                        ((TextBox)(c)).Text = "";
                    }
                }
            }
            Bitmap bitmap = null;
            pictureBox_faceData.Image = bitmap;
            richTextBox_fingerData.Text = "";
            richTextBox_info.Text = "";
        }

        private void button_readCard_Click(object sender, EventArgs e)
        {
            int iRet; //返回码
            int iPort; //端口号
            int iFPflag; //是否读取指纹
            byte[] pPHMsg = new byte[38862];  //人脸数据
            uint pPHMsgLen;//人脸数据长度
            byte[] pFPMsg = new byte[1024];  //指纹数据
            uint pFPMsgLen;//指纹数据长度
            CardInfoStruct pCardInfoStruct = new CardInfoStruct(1);//个人信息数据结构

            pPHMsgLen = 0;
            pFPMsgLen = 0;
            if (checkBox_ifFinger.Checked == true)
                iFPflag = 1;
            else
                iFPflag = 0;
            iPort = int.Parse(textBox_iPort.Text);

            //1.打开端口
            iRet = FriDecomposeDll.FRI_OpenPort(iPort);
            if (iRet != 0x90)
            {
                AddListBoxItem("打开端口失败！返回值为：0x" + iRet.ToString("x02"), Color.Red);
                FriDecomposeDll.FRI_ClosePort(iPort);
                return;
            }

            //2.找卡
            iRet = FriDecomposeDll.FRI_FindIDCard(iPort);
            if (iRet != 0x90)
            {
                AddListBoxItem("未找到证件！返回值为：0x" + iRet.ToString("x02"), Color.Red);
                FriDecomposeDll.FRI_ClosePort(iPort);
                return;
            }

            //3.读证件信息
            iRet = FriDecomposeDll.FRI_ReadIDCard(iPort, ref pCardInfoStruct, pPHMsg, ref pPHMsgLen, pFPMsg, ref pFPMsgLen, iFPflag);
            if (iRet != 0x90)
            {
                AddListBoxItem("读证件信息失败！返回值为：0x" + iRet.ToString("x02"), Color.Red);
                FriDecomposeDll.FRI_ClosePort(iPort);
                return;
            }
            else
            {
                AddListBoxItem("读证件信息成功！", Color.Green);
                showData(pCardInfoStruct);

                MemoryStream memoryStream = new MemoryStream(pPHMsg);
                Bitmap bitmap = new Bitmap(memoryStream);
                pictureBox_faceData.Image = bitmap;

                if (iFPflag == 1)
                {
                    string str = "";
                    for (int i = 0; i < pFPMsgLen; ++i)
                        str += pFPMsg[i].ToString("x02") + " ";
                    richTextBox_fingerData.Text = str;
                }
            }

            //4.关闭端口
            FriDecomposeDll.FRI_ClosePort(iPort);
        }
    }
}
